<?php
class ControllerPaymenterip extends Controller {
	protected function index() {
		$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');
		$this->data['redirect'] = $this->url->link('payment/erip/ep_redirect');
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		if ($this->request->get['route'] != 'checkout/guest_step_3') {
			$this->data['cancel_return'] = $this->url->link('checkout/payment');
		} else {
			$this->data['cancel_return'] = $this->url->link('checkout/guest_step_2');
		}
		
		if ($this->request->get['route'] != 'checkout/guest_step_3') {
			$this->data['back'] = $this->url->link('checkout/payment');
		} else {
			$this->data['back'] = $this->url->link('checkout/guest_step_2');
		}
		
		$this->id = 'payment';
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/erip.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/erip.tpl';
		} else {
			$this->template = 'default/template/payment/erip.tpl';
		}
		$this->render();
	}
	
	//Ошибка оплаты
	public function fail() {
		$this->cart->clear();//Очищение корзины
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/erip_failure.tpl')) {
				$this->template = $this->config->get('config_template') . '/template/payment/erip_failure.tpl';
			} else {
				$this->template = 'default/template/payment/erip_failure.tpl';
			}
			//Изменение статуса в случае ошибки
			$this->load->model('checkout/order');
			$this->model_checkout_order->update($this->session->data['order_id'], $this->config->get('erip_cancel_status_id'));
			$this->response->setOutput($this->render());
			//Подключение шаблонов страницы
			$this->children = array(
				'common/column_left',
				'common/column_right',
				'common/content_top',
				'common/content_bottom',
				'common/footer',
				'common/header'	
			);

			$this->response->setOutput($this->render());
	}

	//Перенаправление клиента после оплаты
	public function success() {
		$order_id = $this->request->get['EP_OrderNo'];//Получение номера заказа
		$this->data['order_id'] = $order_id;
		$this->cart->clear();//Очищение корзины
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/erip_success.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/erip_success.tpl';
		} else {
			$this->template = 'default/template/payment/erip_success.tpl';
		}
		//Подключение шаблонов страницы
		$this->children = array(
			'common/column_left',
			'common/column_right',
			'common/content_top',
			'common/content_bottom',
			'common/footer',
			'common/header'	
		);

		$this->response->setOutput($this->render());		
	}

	//Уведомление об оплате
	public function notify() {
		$order_mer_code = $this->request->post['order_mer_code'];
		$sum            = $this->request->post['sum'];
		$mer_no         = $this->request->post['mer_no'];
		$card           = $this->request->post['card'];
		$purch_date     = $this->request->post['purch_date'];
		$web_key        = $this->config->get('erip_webkey');
		$notify_sig     = $this->request->post['notify_signature'];
				
		$sig = md5($order_mer_code.$sum.$mer_no.$card.$purch_date.$web_key);

		//Проверка электронной подписи
		if ($sig == $notify_sig){
			header("HTTP/1.0 200 OK");
			print $status = 'OK | the notice is processed';
			$this->load->model('checkout/order');
			$this->model_checkout_order->update($order_mer_code, $this->config->get('erip_processing_status_id'));
		} else {
			header("HTTP/1.0 400 Bad Request");
			print $status = 'FAILED | incorrect digital signature';
		}

	}
	//Перенаправление на страницу /weborder/
	public function ep_redirect() {
		$this->data['action'] = 'https://ssl.easypay.by/weborder/';
		$this->data['merchant']    = $this->config->get('erip_merchant');  
		$this->data['order_id']    = $this->session->data['order_id'];
		$this->data['EP_OrderInfo'] = "Заказ №".$this->data['order_id'];

		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$this->data['expires']     = $this->config->get('erip_expires');
		$this->data['hash']        = md5($this->config->get('erip_merchant').$this->config->get('erip_webkey'). $this->session->data['order_id'].$order_info['total']);

		$this->data['EP_Comment'] = "Заказ от магазина ".$order_info['store_name'];
		$this->data['amount'] = $order_info['total'];
		$this->data['return'] = $this->url->link('payment/erip/success');
		$this->data['fail']   = $this->url->link('payment/erip/fail');

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/erip_redirect.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/erip_redirect.tpl';
		} else {
			$this->template = 'default/template/payment/erip_redirect.tpl';
		}
		
		$this->model_checkout_order->confirm($this->data['order_id'], $this->config->get('erip_pending_status_id'));
		$this->response->setOutput($this->render());
	}

}

?>